<?php

/**
 **  cas_auth/setup.php
 **
 **  Copyright (c) 2008 Eole (eole@ac-dijon.fr)
 **  Licensed under the GNU GPL. For full terms see the file COPYING.
 **
 **  Authentication through phpCAS
 **
 **/
include_once('CAS/CAS.php');
include('configCAS/cas.inc.php');
include('config.php');
define('__CAS_URL', "");
if (__CAS_DEBUG){
    phpCAS::setDebug('/var/log/posh/cas-webshare.log');
}

function init_proxy(){
    phpCAS::proxy(__CAS_VERSION, __CAS_SERVER, __CAS_PORT, __CAS_URL, false);
    if (method_exists(phpCAS, 'setNoCasServerValidation')){
        phpCAS::setNoCasServerValidation();
    }
}
function auth(){
    # Authentification de l'application web
    if (method_exists(phpCAS, 'setFixedServiceURL')){
        $orig_url = $_SERVER['SCRIPT_URI'];
        $url = str_replace('start.php', 'index.php', $orig_url);
        phpCAS::setFixedServiceURL($url);
    }
    $auth = phpCAS::isAuthenticated();
    if ( ! $auth )  {
        if ( ! __GATEWAY) phpCAS::forceAuthentication();
        elseif (! isset($_GET['ticket'])) phpCAS::checkAuthentication();
    }
    return $auth;
}
function set_pgt($CAS){
    /// Récupère un PGT
    if( ! empty($_GET['ticket']) ||
        ! empty($_GET['pgtIou'])) {
        if( ! empty($_SESSION['PGT'])) {
            session_unset();
            $_GET['ticket']='';
        }
        if($CAS->hasPGT()) {
            $PGT=$CAS->getPGT();
            $_SESSION['PGT']=$PGT;
        }
    }
}
function cas_auth_get_pt () {
    session_start();
    init_proxy();
    $auth = auth();
    # Récupération du pt pour le service ftp
     if (method_exists(phpCAS, 'setFixedServiceURL')){
        phpCAS::setFixedServiceURL(__FTP_SERVICE);
    }
	$CAS = $GLOBALS['PHPCAS_CLIENT'];
    if ($auth) {
        set_pgt($CAS);
        // procedure to obtain or reobtain a PT
        if($CAS->hasPGT()) {
          $PT = $CAS->retrievePT(__FTP_SERVICE ,$err_code,$output);
          $_SESSION['PT']=$PT;
          $USER=$CAS->getUser();
          $CREDENTIAL=$_SESSION['PT'];
        }
        $_SESSION['username'] = $USER;
        $_SESSION['password'] = $CREDENTIAL;
        $_SESSION['pts'] = $CREDENTIAL;
        phpCAS::log('CAS complete : '.$USER.' '.$CREDENTIAL);

	if(empty($USER) ||
             empty($CREDENTIAL)) {
		     session_unset();
		     session_destroy();
             header('Location: index.php');
            }
    }
}
function cas_auth_logout () {
    session_unset();
    phpCAS::proxy(__CAS_VERSION, __CAS_SERVER, __CAS_PORT, __CAS_URL, false);
    if (method_exists(phpCAS, "setNoCasServerValidation")){
        phpCAS::setNoCasServerValidation();
    }
    if (method_exists(phpCAS, 'logoutWithUrl')){
        phpCAS::logoutWithUrl($_SERVER["SCRIPT_URI"]);
    }else{
        phpCAS::logout($_SERVER["SCRIPT_URI"]);
    }
}
//place un nouveau ticket dans la session
//necessite l'appelle de phpCAS::proxy
function get_pt(){
   if (method_exists(phpCAS, 'setFixedServiceURL')){
      phpCAS::setFixedServiceURL(__FTP_SERVICE);
   }

   $CAS = $GLOBALS['PHPCAS_CLIENT']; // cf CAS-1.0.1/CAS.php ligne195
   if($CAS->hasPGT()) {	 // if there is a PGT
      $PT = $CAS->retrievePT(__FTP_SERVICE,$err_code,$output);             // on récupère un PT
      $_SESSION['PT']=$PT;
      $CREDENTIAL=$_SESSION['PT'];
      $_SESSION['pts'] = $CREDENTIAL;
   }
}
